{   The_GUI - Frontend for a couple of command-line tools
    Copyright (C) 2004  Spasic Boban (spasic7@hotmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA }

unit MkisoGUI;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, StrUtils, IniFiles, SHELLAPI;

type
  TMkisofs_form = class(TForm)
    GroupFS: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    GroupOptions: TGroupBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    CheckBox12: TCheckBox;
    GroupInfo: TGroupBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    GroupBoot: TGroupBox;
    CheckBoot: TCheckBox;
    Edit5: TEdit;
    Label5: TLabel;
    BTopenBimg: TButton;
    FolderBox: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    Button1: TButton;
    Button2: TButton;
    Edit7: TEdit;
    Edit8: TEdit;
    NoEmulBox: TCheckBox;
    MkBatBT: TButton;
    RunBatBT: TButton;
    Quit: TButton;
    Label9: TLabel;
    Edit9: TEdit;
    Button3: TButton;
    OpenDialog1: TOpenDialog;
    HideGroup: TGroupBox;
    CheckBox14: TCheckBox;
    CheckBox15: TCheckBox;
    SaveTemplate: TButton;
    OpenTemplate: TButton;
    Edit6: TEdit;
    OtherParam: TCheckBox;
    OpenDialog2: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Edit13: TEdit;
    Label10: TLabel;
    Edit12: TEdit;
    Button4: TButton;
    Label6: TLabel;
    CheckBox16: TCheckBox;
    Edit14: TEdit;
    CheckBox20: TCheckBox;
    OpenDialog3: TOpenDialog;
    ClearBT: TButton;
    SpinEdit1: TSpinEdit;
    Edit15: TEdit;
    Label12: TLabel;
    CheckBox21: TCheckBox;
    CheckBox22: TCheckBox;
    CheckBox23: TCheckBox;
    Edit16: TEdit;
    CheckBox17: TCheckBox;
    CheckBox18: TCheckBox;
    Edit10: TEdit;
    CheckBox19: TCheckBox;
    Edit11: TEdit;
    CheckBox24: TCheckBox;
    CheckBox25: TCheckBox;
    Button6: TButton;
    CheckBox26: TCheckBox;
    CheckBox2: TCheckBox;
    Button5: TButton;
    Edit17: TEdit;
    OpenDialog4: TOpenDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure CheckBootClick(Sender: TObject);
    procedure QuitClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure BTopenBimgClick(Sender: TObject);
    procedure CheckBox18Click(Sender: TObject);
    procedure CheckBox19Click(Sender: TObject);
    procedure OtherParamClick(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure CheckBox7Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure SaveTemplateClick(Sender: TObject);
    procedure OpenTemplateClick(Sender: TObject);
    procedure CheckBox16Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ClearBTClick(Sender: TObject);
    procedure CheckBox20Click(Sender: TObject);
    procedure MkBatBTClick(Sender: TObject);
    procedure RunBatBTClick(Sender: TObject);
    procedure Edit5Change(Sender: TObject);
    procedure CheckBox23Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Edit7Change(Sender: TObject);
    procedure Edit8Change(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Mkisofs_form: TMkisofs_form;
  debug: boolean;
implementation

{$R *.dfm}
uses selector, comments, console_capture, debug_unit;

function removeroot(ulaz: string; ulaz2: string): string;
var
  temp: string;
begin
  Temp := ulaz;
  temp := AnsiReplaceStr(temp, ulaz2, '');
  result := temp;
end;

function WinToLin(ulaz: string): string;
var
  temp: string;
begin
  temp := ulaz;
  temp := AnsiReplaceStr(temp, '\', '/');
  result := temp;
end;

function codeCR(ulaz: string): string;
var
  temp: string;
begin
  temp := ulaz;
  temp := AnsiReplaceStr(temp, chr(10), chr(254));
  temp := AnsiReplaceStr(temp, chr(13), chr(253));
  result := temp;
end;

function decodeCR(ulaz: string): string;
var
  temp: string;
begin
  temp := ulaz;
  temp := AnsiReplaceStr(temp, chr(254), chr(10));
  temp := AnsiReplaceStr(temp, chr(253), chr(13));
  result := temp;
end;

procedure Tmkisofs_form.Button1Click(Sender: TObject);
var
  RootCD: string;
begin
  SelectForm.ShowModal;
  RootCD := SelectForm.ShellTreeView1.Path;
  if rightStr(RootCD, 1) <> '\' then
    RootCD := RootCD + '\';
  Edit7.Text := RootCD;
end;

procedure Tmkisofs_form.Button2Click(Sender: TObject);
var
  OutIMG: string;
begin
  SelectForm.ShowModal;
  OutIMG := SelectForm.ShellTreeView1.Path;
  if rightStr(OutIMG, 1) <> '\' then
    OutIMG := OutIMG + '\';
  Edit8.Text := OutIMG;
end;

procedure Tmkisofs_form.CheckBootClick(Sender: TObject);
begin
  if CheckBoot.Checked = true then
  begin
    CheckBox17.Enabled := true;
    CheckBox18.Enabled := true;
    checkBox19.Enabled := true;
    CheckBox14.Enabled := true;
    checkBox15.Enabled := true;
    BTopenBimg.Enabled := true;
    Edit5.Enabled := true;
    NoEmulBox.Enabled := true;
  end;
  if CheckBoot.Checked = false then
  begin
    CheckBox17.Enabled := false;
    CheckBox18.Enabled := false;
    checkBox19.Enabled := false;
    CheckBox14.Enabled := false;
    checkBox15.Enabled := false;
    BTopenBimg.Enabled := false;
    Edit5.Enabled := false;
    NoEmulBox.Enabled := false;
  end;
end;

procedure Tmkisofs_form.QuitClick(Sender: TObject);
begin
  close;
end;

procedure Tmkisofs_form.Button3Click(Sender: TObject);
var
  BatFld: string;
begin
  SelectForm.ShowModal;
  BatFld := SelectForm.ShellTreeView1.Path;
  if rightStr(BatFld, 1) <> '\' then
    BatFld := BatFld + '\';
  Edit9.Text := BatFld;
end;

procedure Tmkisofs_form.BTopenBimgClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    Edit5.Text := (OpenDialog1.Filename);
  end;

end;

procedure Tmkisofs_form.CheckBox18Click(Sender: TObject);
begin
  if CheckBox18.Checked = true then
    Edit10.Enabled := true;
  if CheckBox18.Checked = false then
    Edit10.Enabled := false;
end;

procedure Tmkisofs_form.CheckBox19Click(Sender: TObject);
begin
  if CheckBox19.Checked = true then
    Edit11.Enabled := true;
  if CheckBox19.Checked = false then
    Edit11.Enabled := false;
end;

procedure Tmkisofs_form.OtherParamClick(Sender: TObject);
begin
  if OtherParam.Checked = true then
    Edit6.Enabled := true;
  if OtherParam.Checked = false then
    Edit6.Enabled := false;
end;

procedure Tmkisofs_form.CheckBox6Click(Sender: TObject);
begin
  if CheckBox6.Checked = true then
    CheckBox7.Checked := false;
end;

procedure Tmkisofs_form.CheckBox7Click(Sender: TObject);
begin
  if CheckBox7.Checked = true then
    CheckBox6.Checked := false;
end;

procedure Tmkisofs_form.CheckBox5Click(Sender: TObject);
begin
  if checkbox5.Checked = true then
  begin
    SpinEdit1.Enabled := true;
    checkbox20.Checked := false;
  end;
  if checkbox5.Checked = false then
  begin
    SpinEdit1.enabled := false;
  end;
end;

procedure Tmkisofs_form.SaveTemplateClick(Sender: TObject);
var
  Ini: TIniFile;
begin
  if SaveDialog1.Execute then
  begin
    Ini := TIniFile.Create(SaveDialog1.FileName);
    try
      Ini.WriteString('Make_ISO template file', 'version', '2');
      Ini.WriteBool('File', 'Joliet', CheckBox1.Checked);
      Ini.WriteBool('File', 'Joliet_long', CheckBox3.checked);
      Ini.WriteBool('File', 'full_ISO', CheckBox7.Checked);
      Ini.WriteBool('File', 'max_ISO', CheckBox6.checked);
      Ini.WriteBool('File', 'RRRidge', CheckBox4.Checked);
      Ini.WriteBool('File', 'ISO_level', CheckBox5.checked);
      Ini.WriteInteger('File', 'ISO_level_value', SpinEdit1.Value);
      Ini.WriteBool('File', 'ISO9660:1999', CheckBox20.checked);
      Ini.WriteBool('Advanced', 'Omit_ver_nr', CheckBox8.checked);
      Ini.WriteBool('Advanced', 'Verbose', CheckBox9.Checked);
      Ini.WriteBool('Advanced', 'multidot', CheckBox12.Checked);
      Ini.WriteBool('Advanced', 'omit_period', CheckBox21.Checked);
      Ini.WriteBool('Advanced', 'allow_lowercase', CheckBox22.Checked);
      Ini.WriteBool('Advanced', 'no_iso_translate', CheckBox24.checked);
      Ini.WriteBool('Advanced', 'relaxed_filenames', CheckBox25.checked);
      Ini.WriteBool('Advanced', 'charset', CheckBox16.checked);
      Ini.WriteString('Advanced', 'charset_value', Edit14.Text);
      Ini.WriteString('Folders', 'root_folder', Edit7.Text);
      Ini.WriteString('Folders', 'output_folder', Edit8.Text);
      Ini.WriteString('Folders', 'output_filename', Edit13.Text);
      Ini.WriteString('Folders', 'batch_folder', Edit9.Text);
      Ini.WriteString('Folders', 'mkisofs_folder', Edit12.Text);
      Ini.WriteBool('boot', 'bootable', CheckBoot.Checked);
      Ini.WriteString('boot', 'boot_image', Edit5.Text);
      Ini.WriteBool('boot', 'no_emulation', NoEmulBox.Checked);
      Ini.WriteBool('boot', 'boot_info_table', CheckBox17.checked);
      Ini.WriteBool('boot', 'boot_load_segment', CheckBox18.Checked);
      Ini.WriteString('boot', 'blsegment_value', Edit10.Text);
      Ini.WriteBool('boot', 'boot_load_size', CheckBox19.checked);
      Ini.WriteString('boot', 'blsize_value', Edit11.Text);
      Ini.WriteString('Info', 'preparer', Edit1.Text);
      Ini.WriteString('Info', 'volume_ID', Edit2.Text);
      Ini.WriteString('Info', 'app_ID', Edit3.Text);
      Ini.WriteString('Info', 'publisher_ID', Edit4.Text);
      Ini.WriteString('Info', 'sys_ID', Edit15.Text);
      Ini.WriteBool('Hide', 'boot_cat', CheckBox14.checked);
      Ini.WriteBool('Hide', 'joliet_boot_cat', CheckBox15.checked);
      Ini.WriteBool('Other', 'sorting', CheckBox2.Checked);
      Ini.WriteString('Other', 'sorting_list', Edit17.Text);
      Ini.WriteBool('Other', 'other_param', OtherParam.checked);
      Ini.Writestring('Other', 'other_param_value', Edit6.text);
      Ini.WriteBool('Other', 'other_param_2', Checkbox23.checked);
      Ini.Writestring('Other', 'other_param_value_2', Edit16.text);
      Ini.WriteString('Comments', 'comment_1',
        codeCR(Comments_form.Memo1.Lines.Text));
      Ini.WriteBool('Alex', 'duplicates_once', checkbox26.Checked);
    finally
      Ini.Free;
    end;
  end;

end;

procedure Tmkisofs_form.OpenTemplateClick(Sender: TObject);
var
  version: string;
  Ini: TIniFile;
begin
  if OpenDialog2.Execute then
  begin
    version := '';
    Ini := TIniFile.Create(OpenDialog2.FileName);
    try
      version := Ini.ReadString('Make_ISO template file', 'version', '0');
      if version = '2' then
      begin
        CheckBox1.Checked := Ini.ReadBool('File', 'Joliet', true);
        CheckBox3.Checked := Ini.ReadBool('File', 'Joliet_long', true);
        CheckBox7.Checked := Ini.ReadBool('File', 'full_ISO', true);
        CheckBox6.Checked := Ini.ReadBool('File', 'max_ISO', false);
        CheckBox4.Checked := Ini.ReadBool('File', 'RRRidge', true);
        CheckBox5.Checked := Ini.ReadBool('File', 'ISO_level', false);
        SpinEdit1.Value := Ini.ReadInteger('File', 'ISO_level_value', 1);
        CheckBox20.checked := Ini.ReadBool('File', 'ISO9660:1999', true);
        CheckBox8.Checked := Ini.ReadBool('Advanced', 'Omit_ver_nr', true);
        CheckBox9.Checked := Ini.ReadBool('Advanced', 'Verbose', true);
        CheckBox12.Checked := Ini.ReadBool('Advanced', 'multidot', false);
        CheckBox21.Checked := Ini.ReadBool('Advanced', 'omit_period', false);
        CheckBox22.Checked := Ini.ReadBool('Advanced', 'allow_lowercase',
          false);
        CheckBox24.Checked := Ini.ReadBool('Advanced', 'no_iso_translate',
          false);
        CheckBox25.Checked := Ini.ReadBool('Advanced', 'relaxed_filenames',
          false);
        CheckBox16.Checked := Ini.ReadBool('Advanced', 'charset', false);
        Edit14.Text := Ini.ReadString('Advanced', 'charset_value', '');
        Edit7.Text := Ini.ReadString('Folders', 'root_folder', '');
        Edit8.Text := Ini.ReadString('Folders', 'output_folder', '');
        Edit13.Text := Ini.ReadString('Folders', 'output_filename', '');
        Edit9.Text := Ini.ReadString('Folders', 'batch_folder', '');
        Edit12.Text := Ini.ReadString('Folders', 'mkisofs_folder', '');
        CheckBoot.Checked := Ini.ReadBool('boot', 'bootable', false);
        Edit5.Text := Ini.ReadString('boot', 'boot_image', '');
        NoEmulBox.Checked := Ini.ReadBool('boot', 'no_emulation', false);
        CheckBox17.Checked := Ini.ReadBool('boot', 'boot_info_table', false);
        CheckBox18.Checked := Ini.ReadBool('boot', 'boot_load_segment', false);
        Edit10.Text := Ini.ReadString('boot', 'blsegment_value', '07C0');
        CheckBox19.Checked := Ini.ReadBool('boot', 'boot_load_size', false);
        Edit11.Text := Ini.ReadString('boot', 'blsize_value', '4');
        Edit1.Text := Ini.ReadString('Info', 'preparer', '');
        Edit2.Text := Ini.ReadString('Info', 'volume_ID', '');
        Edit3.Text := Ini.ReadString('Info', 'app_ID', '');
        Edit4.Text := Ini.ReadString('Info', 'publisher_ID', '');
        Edit15.Text := Ini.ReadString('Info', 'sys_ID', '');
        CheckBox14.Checked := Ini.ReadBool('Hide', 'boot_cat', true);
        CheckBox15.Checked := Ini.ReadBool('Hide', 'joliet_boot_cat', true);
        CheckBox2.Checked := Ini.ReadBool('Other', 'sorting', false);
        Edit17.Text := Ini.ReadString('Other', 'sorting_list', '');
        OtherParam.Checked := Ini.ReadBool('Other', 'other_param', false);
        Edit6.Text := Ini.Readstring('Other', 'other_param_value', '');
        Checkbox23.Checked := Ini.ReadBool('Other', 'other_param_2', false);
        Edit16.Text := Ini.Readstring('Other', 'other_param_value_2', '');
        Comments_form.Memo1.Lines.Text := decodeCR(Ini.Readstring('Comments',
          'comment_1',
          ''));
        CheckBox26.Checked := Ini.ReadBool('Alex', 'duplicates_once', false);
        if Comments_form.Memo1.Lines.Text <> '' then
        begin
          if MessageDlg('This template contains comments. Show comments ? ',
            mtConfirmation, [mbYes, mbNo], 0) = mrYes then
          begin
            Comments_form.Show;
          end;
        end;
      end
      else
        MessageDlg('Wrong file version', mtInformation, [mbOk], 0)

    finally
      Ini.Free;
    end;
  end;
end;

procedure Tmkisofs_form.CheckBox16Click(Sender: TObject);
begin
  if CheckBox16.Checked = true then
    Edit14.Enabled := true;
  if CheckBox16.Checked = false then
    Edit14.Enabled := false;
end;

procedure Tmkisofs_form.Button4Click(Sender: TObject);
begin
  if OpenDialog3.Execute then
  begin
    edit12.Text := OpenDialog3.FileName;
  end;
end;

procedure Tmkisofs_form.ClearBTClick(Sender: TObject);
begin
  if MessageDlg('Are you sure ? ', mtConfirmation, [mbYes, mbNo], 0) = mrYes
    then
  begin
    CheckBox1.Checked := false;
    CheckBox3.Checked := false;
    CheckBox7.Checked := false;
    CheckBox6.Checked := false;
    CheckBox4.Checked := false;
    CheckBox5.Checked := false;
    SpinEdit1.Value := 1;
    CheckBox20.checked := false;
    CheckBox8.Checked := false;
    CheckBox9.Checked := false;
    CheckBox12.Checked := false;
    checkbox24.Checked := false;
    checkbox25.Checked := false;
    CheckBox17.Checked := false;
    CheckBox18.Checked := false;
    Edit10.Text := '07C0';
    CheckBox19.Checked := false;
    Edit11.Text := '4';
    CheckBox16.Checked := false;
    Edit14.Text := '';
    Edit7.Text := '';
    Edit8.Text := '';
    Edit13.Text := '';
    Edit9.Text := '';
    Edit12.Text := '';
    CheckBoot.Checked := false;
    Edit5.Text := '';
    NoEmulBox.Checked := false;
    Edit1.Text := '';
    Edit2.Text := '';
    Edit3.Text := '';
    Edit4.Text := '';
    CheckBox14.Checked := false;
    CheckBox15.Checked := false;
    OtherParam.Checked := false;
    Edit6.Text := '';
    Checkbox21.Checked := false;
    Checkbox22.Checked := false;
    Checkbox23.Checked := false;
    Edit15.Text := '';
    Edit16.Text := '';
    Edit17.Text := '';
    CheckBox2.Checked := false;
    Comments_form.Memo1.Lines.Text := '';
  end;
end;

procedure Tmkisofs_form.CheckBox20Click(Sender: TObject);
begin
  if checkbox20.Checked = true then
  begin
    checkbox5.Checked := false;
  end;
end;

procedure Tmkisofs_form.MkBatBTClick(Sender: TObject);
var
  temp: string;
  F: TextFile;
  path: string;
  batchpath: string;

begin
  temp := '';
  if Edit12.text = '' then
    MessageDlg('Path to mkisofs.exe isn''t specified', mtInformation, [mbOk], 0)
  else
    temp := temp + '"' + Edit12.Text + '"';
  if checkbox1.Checked = true then
    temp := temp + ' -J';
  if checkbox3.Checked = true then
    temp := temp + ' -joliet-long';
  if checkbox7.Checked = true then
    temp := temp + ' -l';
  if checkbox6.Checked = true then
    temp := temp + ' -max-iso9660-filenames';
  if checkbox4.Checked = true then
    temp := temp + ' -r';
  if checkbox5.Checked = true then
    temp := temp + ' -iso-level ' + intToStr(SpinEdit1.value);
  if checkbox20.Checked = true then
    temp := temp + ' -iso-level 4';
  if checkbox8.Checked = true then
    temp := temp + ' -N';
  if checkbox9.Checked = true then
    temp := temp + ' -v';
  if checkbox12.Checked = true then
    temp := temp + ' -allow-multidot';
  if checkbox21.Checked = true then
    temp := temp + ' -d';
  if checkbox22.Checked = true then
    temp := temp + ' -allow-lowercase';
  if checkbox24.Checked = true then
    temp := temp + ' -no-iso-translate';
  if checkbox25.Checked = true then
    temp := temp + ' -relaxed-filenames';
  if checkbox26.Checked = true then
    temp := temp + ' -duplicates-once';
  if (OtherParam.Checked = true) and (Edit6.Text <> '') then
    temp := temp + ' ' + Edit6.Text;
  if (Checkbox23.Checked = true) and (Edit16.Text <> '') then
    temp := temp + ' ' + Edit16.Text;
  if (Checkbox2.Checked = true) and (Edit17.Text <> '') then
    temp := temp + ' -sort "' + Edit17.Text + '"';
  if (checkbox17.Checked = true) and (checkbox17.Enabled = true) then
    temp := temp + ' -boot-info-table';
  if (checkbox18.Checked = true) and (checkbox18.Enabled = true) then
  begin
    if Edit10.Text = '' then
      MessageDlg('Boot load segment value isn''t specified', mtInformation,
        [mbOk], 0)
    else
      temp := temp + ' -boot-load-seg ' + Edit10.Text;
  end;
  if (checkbox19.Checked = true) and (checkbox19.Enabled = true) then
  begin
    if Edit11.Text = '' then
      MessageDlg('Boot load size value isn''t specified', mtInformation, [mbOk],
        0)
    else
      temp := temp + ' -boot-load-size ' + Edit11.Text;
  end;
  if checkbox16.Checked = true then
  begin
    if Edit14.Text = '' then
      MessageDlg('Output charset isn''t specified', mtInformation, [mbOk], 0)
    else
      temp := temp + ' -output-charset ' + Edit14.Text;
  end;
  if (checkbox14.Checked = true) and (checkbox14.Enabled = true) then
    temp := temp + ' -hide boot.catalog';
  if (checkbox15.Checked = true) and (checkbox15.Enabled = true) then
    temp := temp + ' -hide-joliet boot.catalog';
  if (Edit8.Text = '') or (Edit13.Text = '') then
    MessageDlg('Output folder or file name isn''t specified', mtInformation,
      [mbOk], 0)
  else
    temp := temp + ' -o "' + Edit8.Text + Edit13.Text + '"';
  if checkBoot.Checked = true then
  begin
    if Edit5.Text = '' then
      MessageDlg('Boot image/sector isn''t specified', mtInformation, [mbOk], 0)
    else
      temp := temp + ' -b "' + Edit5.Text + '"';
    if NoEmulBox.Checked = true then
      temp := temp + ' -no-emul-boot';
  end;
  if Edit1.Text <> '' then
    temp := temp + ' -p "' + Edit1.Text + '"';
  if Edit2.Text <> '' then
    temp := temp + ' -volid "' + Edit2.Text + '"';
  if Edit3.Text <> '' then
    temp := temp + ' -appid "' + Edit3.Text + '"';
  if Edit4.Text <> '' then
    temp := temp + ' -P "' + Edit4.Text + '"';
  if Edit15.Text <> '' then
    temp := temp + ' -sysid "' + Edit15.text + '"';
  if Edit7.Text = '' then
    MessageDlg('Root of CD tree isn''t specified', mtInformation, [mbOk], 0)
  else
    temp := temp + ' "' + Edit7.Text + '"';

  batchpath := edit9.Text;
  Setcurrentdir(batchpath);
  path := Edit7.Text;
  AssignFile(F, 'build.bat');
  Rewrite(F);
  Writeln(F, '@echo off');
  Writeln(F, 'echo this file is generated by The_GUI');
  writeln(F, '@echo off');
  Writeln(F, 'rem ------------------------------');
  Writeln(F, '@echo on');
  Writeln(F, temp);
  writeln(F, '@echo off');
  Writeln(F, 'rem ------------------------------');
  Writeln(F, 'pause');
  CloseFile(F);

end;

procedure Tmkisofs_form.RunBatBTClick(Sender: TObject);
var
  batchpath: string;
const
  el = #13 + #10;
  nl = '*****  ';
begin
  if Edit9.Text = '' then
    MessageDlg('Batch folder isn''t specified', mtInformation, [mbOk], 0)
  else
  begin
    batchpath := edit9.Text;
    Setcurrentdir(batchpath);
    console_capture.console.Memo1.Clear;
    console_capture.console.DosCommand1.OutputLines :=
      console_capture.console.Memo1.Lines;
    console_capture.console.DosCommand1.CommandLine := (batchpath +
      'build.bat');
    console_capture.console.DosCommand1.Execute;
    console_capture.console.DosCommand1.SendLine('', true);
    console_capture.console.Showmodal;
    if debug = true then
    begin
      debug_win.Memo1.Text := debug_win.Memo1.Text + el + nl + (batchpath +
        'build.bat') + el;
      debug_win.Memo1.text := debug_win.Memo1.text + console.Memo1.text;
    end;
  end; //else
end;

procedure Tmkisofs_form.Edit5Change(Sender: TObject);
begin
  Edit5.Text := WinToLin(Edit5.Text);
  Edit5.Text := RemoveRoot(Edit5.Text, Edit7.Text);
end;

procedure Tmkisofs_form.CheckBox23Click(Sender: TObject);
begin
  if CheckBox23.Checked = true then
    Edit16.Enabled := true;
  if CheckBox23.Checked = false then
    Edit16.Enabled := false;
end;

procedure Tmkisofs_form.Button6Click(Sender: TObject);
begin
  Comments_form.Show;
end;

procedure TMkisofs_form.FormActivate(Sender: TObject);
var
  mkisofsFind: string;
begin
  if debug = true then
  begin
    debug_win.Memo1.Text := debug_win.Memo1.Text + #13 + #10 +
      '*****  entering Make ISO module' + #13 + #10;
  end;
  Setcurrentdir(ExtractFilePath(Application.EXEName));
  mkisofsFind := FileSearch('mkisofs.exe',
    ExtractFilePath(Application.EXEName));
  if mkisofsFind = '' then
  begin
    ShowMessage('Couldn''t find mkisofs.exe . Please put mkisofs.exe in The_GUI folder');
    RunBatBT.Enabled := false;
  end
  else
    Edit12.Text := ExtractFilePath(Application.EXEName) + 'mkisofs.exe';
end;

procedure TMkisofs_form.Edit7Change(Sender: TObject);
begin
  Edit7.Text := WinToLin(Edit7.Text);
end;

procedure TMkisofs_form.Edit8Change(Sender: TObject);
begin
  Edit8.Text := WinToLin(Edit8.Text);
end;

procedure TMkisofs_form.CheckBox2Click(Sender: TObject);
begin
  if checkbox2.Checked = true then
  begin
    Button5.Enabled := true;
    Edit17.Enabled := true;
  end;
  if checkbox2.Checked = false then
  begin
    button5.Enabled := false;
    Edit17.Enabled := false;
  end;
end;

procedure TMkisofs_form.Button5Click(Sender: TObject);
begin
  if OpenDialog4.Execute then
  begin
    edit17.Text := OpenDialog4.FileName;
    edit17.Text := WinToLin(Edit17.Text);
  end;
end;

end.

