{   The_GUI - Frontend for a couple of command-line tools
    Copyright (C) 2004  Spasic Boban (spasic7@hotmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA }

unit TheGUI;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Buttons, SHELLAPI,
  StdCtrls, Dialogs;

type
  TIntegrator = class(TForm)
    SpeedButton1: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton2: TSpeedButton;
    cbDebug: TCheckBox;
    Label1: TLabel;
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure cbDebugClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Integrator: TIntegrator;
implementation
uses MkisoGUI, rename, about, sorter, cd_op_unit, debug_unit, console_capture,
  other_unit;
{$R *.dfm}

procedure TIntegrator.SpeedButton7Click(Sender: TObject);
begin
  close;
end;

procedure TIntegrator.SpeedButton5Click(Sender: TObject);
begin
  Mkisofs_form.ShowModal;
end;

procedure TIntegrator.SpeedButton1Click(Sender: TObject);
begin
  renamer_form.ShowModal;
end;

procedure TIntegrator.SpeedButton8Click(Sender: TObject);
begin
  about_form.ShowModal;
end;

procedure TIntegrator.SpeedButton3Click(Sender: TObject);
begin
  sorter_form.ShowModal;
end;

procedure TIntegrator.SpeedButton6Click(Sender: TObject);
begin
  CD_Operations.ShowModal;
end;

procedure TIntegrator.SpeedButton4Click(Sender: TObject);
begin
  ShellExecute(Handle, 'open',
    'help.chm', nil, nil, SW_SHOWNORMAL);
end;

procedure TIntegrator.cbDebugClick(Sender: TObject);
begin
  if cbDebug.Checked = true then
  begin
    mkisogui.debug := true;
    cd_op_unit.debug := true;
    console_capture.debug := true;
    debug_unit.Debug_win.Memo1.Clear;
    debug_unit.Debug_win.Show;
  end
  else
  begin
    mkisogui.debug := false;
    cd_op_unit.debug := false;
    console_capture.debug := false;
    debug_unit.Debug_win.Close;
  end;
end;

procedure TIntegrator.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var
  counter: integer;
  captureFind: string;
  debugFind: string;
begin
  Setcurrentdir(ExtractFilePath(Application.EXEName));
  if cbDebug.Checked = true then
    if
      MessageDlg('Debug session was selected, do you want to save the log file? ',
      mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
      counter := debug_win.Memo1.Lines.Count;
      // get out the readcd 'addr: 123456 cn 31' messages
      while counter > 0 do
      begin
        if Pos('ddr', debug_win.Memo1.Lines.Strings[counter]) <> 0 then
          debug_win.Memo1.Lines.Delete(counter);
        counter := counter - 1;
      end;
      if debug_unit.Debug_win.SaveDialog1.Execute then
        debug_unit.Debug_win.Memo1.Lines.SaveToFile(debug_unit.Debug_win.SaveDialog1.FileName);
    end;
  Setcurrentdir(ExtractFilePath(Application.EXEName));
  CaptureFind := FileSearch('capture.tmp',
    ExtractFilePath(Application.EXEName));
  if captureFind <> '' then
    DeleteFile('capture.tmp');
  Setcurrentdir(ExtractFilePath(Application.EXEName));
  debugFind := FileSearch('debug.tmp',
    ExtractFilePath(Application.EXEName));
  if debugFind <> '' then
    DeleteFile('debug.tmp');
end;

procedure TIntegrator.SpeedButton2Click(Sender: TObject);
begin
  other_form.ShowModal;
end;

procedure TIntegrator.FormActivate(Sender: TObject);
var
  f: textfile;
  g: textfile;
  filesPresent1: boolean;
  filesPresent2: boolean;
  filesPresent3: boolean;
  filesPresent4: boolean;
  filesPresent5: boolean;
begin
  if paramcount = 0 then
  begin
    mkisogui.debug := false;
    cd_op_unit.debug := false;
    console_capture.debug := false;
    console_capture.win98 := false;
    debug_unit.win98 := false;
    label1.Caption := 'Running in normal mode';
  end;
  if ParamCount > 0 then
  begin
    if ParamStr(1) = '-win98' then
    begin
      Setcurrentdir(ExtractFilePath(Application.EXEName));
      AssignFile(f, 'capture.tmp');
      rewrite(f);
      closefile(f);
      Setcurrentdir(ExtractFilePath(Application.EXEName));
      AssignFile(g, 'debug.tmp');
      rewrite(g);
      closefile(g);
      console_capture.win98 := true;
      debug_unit.win98 := true;
      label1.Caption := 'Running in Win9x mode';
    end
    else if ParamStr(1) = '-debug' then
    begin
      mkisogui.debug := true;
      cd_op_unit.debug := true;
      console_capture.debug := true;
      console_capture.win98 := false;
      debug_unit.win98 := false;
      cbDebug.Checked := true;
      label1.Caption := 'Running in debug mode';
    end
    else if ParamStr(1) = '-win98debug' then
    begin
      Setcurrentdir(ExtractFilePath(Application.EXEName));
      AssignFile(f, 'capture.tmp');
      rewrite(f);
      closefile(f);
      Setcurrentdir(ExtractFilePath(Application.EXEName));
      AssignFile(g, 'debug.tmp');
      rewrite(g);
      closefile(g);
      mkisogui.debug := true;
      cd_op_unit.debug := true;
      console_capture.debug := true;
      console_capture.win98 := true;
      debug_unit.win98 := true;
      cbDebug.Checked := true;
      label1.Caption := 'Running in Win98 debug mode';
    end
    else
    begin
      mkisogui.debug := false;
      cd_op_unit.debug := false;
      console_capture.debug := false;
      console_capture.win98 := false;
      debug_unit.win98 := false;
      label1.Caption := 'Unknown switch, running in normal mode';
    end;
  end;
  // check the presence of needed files
  filesPresent1 := true;
  filesPresent2 := true;
  filesPresent3 := true;
  filesPresent4 := true;
  filesPresent5 := true;
  if FileSearch('mkisofs.exe', ExtractFilePath(Application.EXEName)) = '' then
    filesPresent1 := false;
  if FileSearch('cdrecord.exe', ExtractFilePath(Application.EXEName)) = '' then
    filesPresent2 := false;
  if FileSearch('readcd.exe', ExtractFilePath(Application.EXEName)) = '' then
    filesPresent3 := false;
  if FileSearch('dd.exe', ExtractFilePath(Application.EXEName)) = '' then
    filesPresent4 := false;
  if FileSearch('bbie.exe', ExtractFilePath(Application.EXEName)) = '' then
    filesPresent5 := false;
  if (filesPresent1 = false) or (filesPresent2 = false) or (filesPresent3 =
    false) or (filesPresent4 = false) or (filesPresent5 = false) then
  begin
    ShowMessage('Needed file is missing. Please read help file about how to install The_GUI');
    ShellExecute(Handle, 'open',
      'help.chm', nil, nil, SW_SHOWNORMAL);
    close;
  end;
end;

end.

