{   The_GUI - Frontend for a couple of command-line tools
    Copyright (C) 2004  Spasic Boban (spasic7@hotmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA }

unit debug_unit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TDebug_win = class(TForm)
    Memo1: TMemo;
    SaveDialog1: TSaveDialog;
    procedure Memo1Change(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Debug_win: TDebug_win;
  win98: boolean;
  g: textfile;

implementation

{$R *.dfm}

procedure ScrollMemoDown(Memo: TMemo);
begin
  SendMessage(Memo.Handle, { HWND of the Memo Control }
    WM_VSCROLL, { Windows Message }
    SB_PAGEDOWN, { Scroll Command }
    0) { Not Used }
end;

procedure ScrollMemoUp(Memo: TMemo);
begin
  SendMessage(Memo.Handle, { HWND of the Memo Control }
    WM_VSCROLL, { Windows Message }
    SB_PAGEUP, { Scroll Command }
    0); { Not Used }
end;

procedure TDebug_win.Memo1Change(Sender: TObject);
begin
  if win98 = true then
  begin
    Append(g);
    if length(memo1.Text) > 64000 then
    begin
      Writeln(g, memo1.text);
      memo1.Clear;
      Flush(g);
    end;
  end;
  ScrollMemoDown(Memo1);
end;

procedure TDebug_win.FormActivate(Sender: TObject);
begin
  if win98 = true then
  begin
    Setcurrentdir(ExtractFilePath(Application.EXEName));
    AssignFile(g, 'debug.tmp');
  end;
end;

end.

