{   The_GUI - Frontend for a couple of command-line tools
    Copyright (C) 2004  Spasic Boban (spasic7@hotmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA }

unit other_unit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DosCommand, StrUtils;

type
  Tother_form = class(TForm)
    cboxFloppy: TComboBox;
    cboxCDROM: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    OpenDialog1: TOpenDialog;
    btExBS: TButton;
    SaveDialog1: TSaveDialog;
    btExBSF: TButton;
    btFIMG: TButton;
    SaveDialog2: TSaveDialog;
    btISO: TButton;
    DosCommand1: TDosCommand;
    DosCommand2: TDosCommand;
    btClose: TButton;
    Memo1: TMemo;
    btWriteIMG: TButton;
    OpenDialog2: TOpenDialog;
    procedure FormActivate(Sender: TObject);
    procedure btCloseClick(Sender: TObject);
    procedure btExBSClick(Sender: TObject);
    procedure btExBSFClick(Sender: TObject);
    procedure btFIMGClick(Sender: TObject);
    procedure DosCommand1Terminated(Sender: TObject; ExitCode: Cardinal);
    procedure btWriteIMGClick(Sender: TObject);
    procedure btISOClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  other_form: Tother_form;

implementation

{$R *.dfm}

function truncate(ulaz: string): string;
begin
  result := AnsiReplaceStr(ulaz, '\', '');
end;

function truncate2(ulaz: string): string;
begin
  result := AnsiReplaceStr(ulaz, '\', '');
  result := AnsiReplaceStr(result, ':', '');
end;

procedure Tother_form.FormActivate(Sender: TObject);
var
  dwLen: dword;
  buf: string;
  p: pchar;
  bbieFind: string;
  ddFind: string;
  bbieFound: boolean;
  ddFound: boolean;

begin
  cboxFloppy.Items.Clear;
  cboxCDROM.Items.Clear;
  cboxFloppy.Items.BeginUpdate;
  dwLen := GetLogicalDriveStrings(0, nil);
  if (dwLen > 0) then
  begin
    SetLength(buf, dwLen);
    if (GetLogicalDriveStrings(dwLen, @buf[1]) = dwLen - 1) then
    begin
      p := pchar(buf);
      while (p[0] <> #0) do
      begin
        case GetDriveType(p) of
          DRIVE_REMOVABLE:
            cboxFloppy.Items.Add(p);
        end;
        inc(p, lstrlen(p) + 1);
      end;
    end;
    SetLength(buf, 0);
  end;
  cboxFloppy.Items.EndUpdate;
  cboxCDROM.Items.BeginUpdate;
  dwLen := GetLogicalDriveStrings(0, nil);
  if (dwLen > 0) then
  begin
    SetLength(buf, dwLen);
    if (GetLogicalDriveStrings(dwLen, @buf[1]) = dwLen - 1) then
    begin
      p := pchar(buf);
      while (p[0] <> #0) do
      begin
        case GetDriveType(p) of
          DRIVE_CDROM:
            cboxCDROM.Items.Add(p);
        end;
        inc(p, lstrlen(p) + 1);
      end;
    end;
    SetLength(buf, 0);
  end;
  cboxCDROM.Items.EndUpdate;
  Setcurrentdir(ExtractFilePath(Application.EXEName));
  bbieFound := false;
  ddFound := false;
  bbieFind := FileSearch('bbie.exe', ExtractFilePath(Application.EXEName));
  if bbieFind = '' then
  begin
    ShowMessage('Couldn''t find bbie.exe . Please download it from www.nu2.nu/bbie and copy it to The_GUI folder');
    bbieFound := false;
  end
  else
    bbieFound := true;
  ddFind := FileSearch('dd.exe', ExtractFilePath(Application.EXEName));
  if ddFind = '' then
  begin
    ShowMessage('Couldn''t find dd.exe . Please copy it to The_GUI folder');
    ddFound := false;
  end
  else
    ddFound := true;
  if cboxFloppy.Items.Strings[0] <> '' then
    cboxFloppy.ItemIndex := 0;
  if cboxCDROM.Items.Strings[0] <> '' then
    cboxCDROM.ItemIndex := 0;
  if bbieFound = true then
  begin
    btExBS.Enabled := true;
    btExBSF.Enabled := true;
  end;
  if ddFound = true then
  begin
    btFIMG.Enabled := true;
    btISO.Enabled := true;
    btWriteIMG.Enabled := true;
  end;
end;

procedure Tother_form.btCloseClick(Sender: TObject);
begin
  Close;
end;

procedure Tother_form.btExBSClick(Sender: TObject);
begin
  Setcurrentdir(ExtractFilePath(Application.EXEName));
  Memo1.Clear;
  Memo1.Text := 'Please wait...';
  DosCommand1.OutputLines := Memo1.Lines;
  DosCommand1.CommandLine := ('bbie ' + truncate(cboxCDROM.Text));
  DosCommand1.Execute;
  btExBS.Enabled := false;
  btExBSF.Enabled := false;
  btFIMG.Enabled := false;
  btISO.Enabled := false;
  btWriteIMG.Enabled := false;
  btClose.Enabled := false;
end;

procedure Tother_form.btExBSFClick(Sender: TObject);
var
  name: string;

begin
  if OpenDialog1.Execute then
    name := OpenDialog1.FileName;
  Setcurrentdir(ExtractFilePath(Application.EXEName));
  Memo1.Clear;
  Memo1.Text := 'Please wait...';
  DosCommand1.OutputLines := Memo1.Lines;
  DosCommand1.CommandLine := ('bbie ' + '"' + name + '"');
  DosCommand1.Execute;
  btExBS.Enabled := false;
  btExBSF.Enabled := false;
  btFIMG.Enabled := false;
  btISO.Enabled := false;
  btWriteIMG.Enabled := false;
  btClose.Enabled := false;
end;

procedure Tother_form.btFIMGClick(Sender: TObject);
var
  name: string;

begin
  if SaveDialog1.Execute then
    name := SaveDialog1.FileName;
  Setcurrentdir(ExtractFilePath(Application.EXEName));
  Memo1.Clear;
  Memo1.Text := 'Please wait...';
  DosCommand1.OutputLines := Memo1.Lines;
  DosCommand1.CommandLine := ('dd if=' + '\\.\' + truncate(cboxFloppy.Text) +
    ' of="' + name + '"');
  DosCommand1.Execute;
  btExBS.Enabled := false;
  btExBSF.Enabled := false;
  btFIMG.Enabled := false;
  btISO.Enabled := false;
  btWriteIMG.Enabled := false;
  btClose.Enabled := false;
end;

procedure Tother_form.DosCommand1Terminated(Sender: TObject;
  ExitCode: Cardinal);
begin
  btExBS.Enabled := true;
  btExBSF.Enabled := true;
  btFIMG.Enabled := true;
  btISO.Enabled := true;
  btWriteIMG.Enabled := true;
  btClose.Enabled := true;
end;

procedure Tother_form.btWriteIMGClick(Sender: TObject);
var
  name: string;
  f: file of Byte;
begin
  if opendialog2.Execute then
    name := opendialog2.FileName;
  AssignFile(f, OpenDialog2.FileName);
  reset(f);
  if FileSize(f) < 1474561 then
  begin
    closefile(f);
    Setcurrentdir(ExtractFilePath(Application.EXEName));
    Memo1.Clear;
    Memo1.Text := 'Please wait...';
    DosCommand1.OutputLines := Memo1.Lines;
    DosCommand1.CommandLine := ('dd if="' + name + '" of=' + '\\.\' +
      truncate(cboxFloppy.Text));
    DosCommand1.Execute;
    btExBS.Enabled := false;
    btExBSF.Enabled := false;
    btFIMG.Enabled := false;
    btISO.Enabled := false;
    btWriteIMG.Enabled := false;
    btClose.Enabled := false;
  end
  else
  begin
    closefile(f);
    MessageDlg('File size > 1.44mb',
      mtConfirmation, [mbOK], 0);
  end;
end;

procedure Tother_form.btISOClick(Sender: TObject);
var
  name: string;

begin
  if SaveDialog2.Execute then
    name := SaveDialog2.FileName;
  Setcurrentdir(ExtractFilePath(Application.EXEName));
  Memo1.Clear;
  Memo1.Text := 'Please wait...';
  DosCommand1.OutputLines := Memo1.Lines;
  DosCommand1.CommandLine := ('dd if=' + '\\.\' + truncate(cboxCDROM.Text) +
    ' of="' + name + '"');
  DosCommand1.Execute;
  btExBS.Enabled := false;
  btExBSF.Enabled := false;
  btFIMG.Enabled := false;
  btISO.Enabled := false;
  btWriteIMG.Enabled := false;
  btClose.Enabled := false;
end;

end.

