{   The_GUI - Frontend for a couple of command-line tools
    Copyright (C) 2004  Spasic Boban (spasic7@hotmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA }

unit rename;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, ShellCtrls, ShellAPI;

type
  Trenamer_form = class(TForm)
    Button1: TButton;
    ListBox2: TListBox;
    Button2: TButton;
    Button4: TButton;
    ListBox1: TListBox;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    ShellTreeView1: TShellTreeView;
    Button5: TButton;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox2: TCheckBox;
    GroupBox2: TGroupBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    GroupBox3: TGroupBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    Button10: TButton;
    Button3: TButton;
    Label1: TLabel;
    Button11: TButton;
    Edit1: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure CheckBox7Click(Sender: TObject);
    procedure CheckBox8Click(Sender: TObject);
    procedure CheckBox9Click(Sender: TObject);
    procedure CheckBox10Click(Sender: TObject);
    procedure CheckBox11Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure ShellTreeView1Change(Sender: TObject; Node: TTreeNode);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  renamer_form: Trenamer_form;

implementation

{$R *.dfm}

procedure RenameDir(DirFrom, DirTo: string);
var
  shellinfo: TSHFileOpStruct;
begin
  with shellinfo do
  begin
    Wnd := 0;
    wFunc := FO_RENAME;
    pFrom := PChar(DirFrom);
    pTo := PChar(DirTo);
    {fFlags := FOF_FILESONLY or FOF_ALLOWUNDO or
              FOF_SILENT or FOF_NOCONFIRMATION;}
    fFlags := FOF_ALLOWUNDO or
      FOF_SILENT or FOF_NOCONFIRMATION;
  end;
  SHFileOperation(shellinfo);
  if SHFileOperation(shellinfo) = 1 then
    MessageDlg('folder not renamed', mtInformation, [mbOk], 0);
end;

function FindFiles(Directory: string; InclAttr, ExclAttr: Integer;
  const SubDirs: Boolean; const Files: TStrings): Integer;
var
  SearchRec: TSearchRec;
begin
  Directory := IncludeTrailingPathDelimiter(Directory);
  FillChar(SearchRec, SizeOf(SearchRec), 0);
  if FindFirst(Directory + '*.*', faAnyFile, SearchRec) = 0 then
  begin
    try
      repeat
        if (SearchRec.Name <> '.') and (SearchRec.Name <> '..') then
          if ((SearchRec.Attr and InclAttr > 0) or ((SearchRec.Attr = 0) and
            (InclAttr <> faDirectory))) and
            (SearchRec.Attr and ExclAttr = 0) then
          begin
            Files.Add(Directory + SearchRec.Name);
            if SubDirs then
              if SearchRec.Attr and faDirectory <> 0 then
                FindFiles(Directory + SearchRec.Name, InclAttr, ExclAttr,
                  SubDirs, Files);
          end;
      until
        FindNext(SearchRec) <> 0;
    finally
      FindClose(SearchRec);
    end;
  end;
  Result := Files.Count;
end;

procedure Trenamer_form.Button1Click(Sender: TObject);
var
  sl: TStringList;
  include: integer;
  exclude: integer;
  subfolders: boolean;
  rootfolder: string;

begin
  include := 0;
  exclude := 0;
  subfolders := false;
  rootfolder := ShellTreeView1.path;
  if checkbox1.Checked = true then
  begin
    Listbox1.Items.Add(rootfolder);
    include := faDirectory;
  end;
  if checkbox2.Checked = true then
    include := include or faAnyFile;
  if checkbox3.Checked = true then
    subfolders := true;
  if checkbox3.Checked = false then
    exclude := faDirectory;

  sl := TStringList.Create;

  begin
    try
      FindFiles(rootfolder, include, exclude, subfolders, sl);
      Listbox1.Items.AddStrings(sl);
    finally
      sl.Free;
    end;
  end;

end;

procedure Trenamer_form.Button2Click(Sender: TObject);
var
  counter: integer;
begin
  counter := 0;
  while counter < (Listbox1.Count) do
  begin
    if listbox1.Selected[counter] then
    begin
      Listbox2.Items.Add(Listbox1.Items.Strings[counter]);
    end;
    counter := counter + 1;
  end;
  Listbox2.Refresh;
end;

procedure Trenamer_form.Button4Click(Sender: TObject);
var
  counter: integer;
begin
  counter := 0;
  while counter < (Listbox2.Items.Count) do
  begin
    RenameFile(Listbox1.Items.Strings[counter],
      (AnsiUpperCaseFileName(Listbox2.Items.Strings[counter])));
    RenameDir(Listbox1.Items.Strings[counter],
      (AnsiUpperCaseFileName(Listbox2.Items.Strings[counter])));
    counter := counter + 1;
  end;
end;

procedure Trenamer_form.Button6Click(Sender: TObject);
begin
  Listbox2.Clear;
end;

procedure Trenamer_form.Button7Click(Sender: TObject);
begin
  ListBox2.DeleteSelected;
end;

procedure Trenamer_form.Button8Click(Sender: TObject);
begin
  ListBox1.Clear;
end;

procedure Trenamer_form.Button9Click(Sender: TObject);
begin
  Listbox1.DeleteSelected;
end;

procedure Trenamer_form.Button5Click(Sender: TObject);
var
  attr: word;
  counter: integer;

begin

  counter := 0;
  while counter < (Listbox2.Items.Count) do
  begin
    attr := FileGetAttr(ListBox2.Items.Strings[counter]);
    if CheckBox4.Checked = true then
      attr := attr or faReadOnly;
    if CheckBox5.Checked = true then
      attr := attr or faArchive;
    if CheckBox6.Checked = true then
      attr := attr or faHidden;
    if CheckBox7.Checked = true then
      attr := attr or faSysFile;
    if CheckBox8.Checked = true then
      attr := attr and not faReadOnly;
    if CheckBox9.Checked = true then
      attr := attr and not faArchive;
    if CheckBox10.Checked = true then
      attr := attr and not faHidden;
    if CheckBox11.Checked = true then
      attr := attr and not faSysFile;
    FileSetAttr(ListBox2.Items.Strings[counter], attr);
    counter := counter + 1;
  end;
end;

procedure Trenamer_form.CheckBox4Click(Sender: TObject);
begin
  if checkbox4.Checked = true then
    checkbox8.Checked := false;
end;

procedure Trenamer_form.CheckBox5Click(Sender: TObject);
begin
  if checkbox5.Checked = true then
    checkbox9.Checked := false;
end;

procedure Trenamer_form.CheckBox6Click(Sender: TObject);
begin
  if checkbox6.Checked = true then
    checkbox10.Checked := false;
end;

procedure Trenamer_form.CheckBox7Click(Sender: TObject);
begin
  if checkbox7.Checked = true then
    checkbox11.Checked := false;
end;

procedure Trenamer_form.CheckBox8Click(Sender: TObject);
begin
  if checkbox8.Checked = true then
    checkbox4.Checked := false;
end;

procedure Trenamer_form.CheckBox9Click(Sender: TObject);
begin
  if checkbox9.Checked = true then
    checkbox5.Checked := false;
end;

procedure Trenamer_form.CheckBox10Click(Sender: TObject);
begin
  if checkbox10.Checked = true then
    checkbox6.Checked := false;
end;

procedure Trenamer_form.CheckBox11Click(Sender: TObject);
begin
  if checkbox11.Checked = true then
    checkbox7.Checked := false;
end;

procedure Trenamer_form.Button10Click(Sender: TObject);
begin
  Listbox1.SelectAll;
end;

procedure Trenamer_form.Button3Click(Sender: TObject);
var
  counter: integer;
begin
  counter := 0;
  while counter < (Listbox2.Items.Count) do
  begin
    RenameFile(Listbox1.Items.Strings[counter],
      (AnsiLowerCaseFileName(Listbox2.Items.Strings[counter])));
    RenameDir(Listbox1.Items.Strings[counter],
      (AnsiLowerCaseFileName(Listbox2.Items.Strings[counter])));
    counter := counter + 1;
  end;
end;

procedure Trenamer_form.Button11Click(Sender: TObject);
begin
  close;
end;

procedure Trenamer_form.ShellTreeView1Change(Sender: TObject;
  Node: TTreeNode);
begin
  Edit1.Text := ShellTreeView1.Path;
end;

end.

